/* This file was generated by plugin 'Nordic Semiconductor nRF5x v.1.2.2' (BDS version 1.1.3139.0) */

#include "service_if.h"
#include <stdint.h>
// #include "app_trace.h" 
#include "ble_quickdraw.h" 

#define NRF_LOG_MODULE_NAME "SERVICE_IF"
#include "nrf_log.h"
#include "nrf_log_ctrl.h"



static ble_quickdraw_t    m_quickdraw; 



/**@brief Function for handling the quickdraw events.
 *
 * @details This function will be called for all quickdraw events which are passed to
 *          the application.
 *
 * @param[in]   p_quickdraw   quickdraw structure.
 * @param[in]   p_evt   Event received from the quickdraw.
 */
static void on_quickdraw_evt(ble_quickdraw_t * p_quickdraw, ble_quickdraw_evt_t * p_evt)
{
    switch (p_evt->evt_type)
    { 
        case BLE_QUICKDRAW_XYZ_EVT_NOTIFICATION_ENABLED:
            NRF_LOG_INFO("[Bluetooth_IF]: QUICKDRAW_XYZ evt NOTIFICATION_ENABLED. \r\n");
            break;
        case BLE_QUICKDRAW_XYZ_EVT_NOTIFICATION_DISABLED:
            NRF_LOG_INFO("[Bluetooth_IF]: QUICKDRAW_XYZ evt NOTIFICATION_DISABLED. \r\n");
            break;
        case BLE_QUICKDRAW_XYZ_EVT_CCCD_WRITE:
            NRF_LOG_INFO("[Bluetooth_IF]: QUICKDRAW_XYZ evt CCCD_WRITE. \r\n");
            break; 
        default:
            // No implementation needed.
            break;
    }
}


/**@brief Function for initializing the Services generated by Bluetooth Developer Studio.
 *
 *
 * @return      NRF_SUCCESS on successful initialization of services, otherwise an error code.
 */
uint32_t bluetooth_init(void)
{
    uint32_t    err_code; 
    ble_quickdraw_init_t    quickdraw_init; 
    

    // Initialize quickdraw.
    memset(&quickdraw_init, 0, sizeof(quickdraw_init));

    quickdraw_init.evt_handler = on_quickdraw_evt; 
    quickdraw_init.is_xyz_read_supported = true;
    memset(&quickdraw_init.ble_quickdraw_xyz_initial_value.x,
           0x00,
           sizeof(quickdraw_init.ble_quickdraw_xyz_initial_value.x));
    memset(&quickdraw_init.ble_quickdraw_xyz_initial_value.y,
           0x00,
           sizeof(quickdraw_init.ble_quickdraw_xyz_initial_value.y));
    memset(&quickdraw_init.ble_quickdraw_xyz_initial_value.z,
           0x00,
           sizeof(quickdraw_init.ble_quickdraw_xyz_initial_value.z));

    err_code = ble_quickdraw_init(&m_quickdraw, &quickdraw_init);
    if (err_code != NRF_SUCCESS)
    {
        return err_code;
    } 

    return NRF_SUCCESS;
}

/**@brief Function for handling the Application's BLE Stack events.
 *
 * @details Handles all events from the BLE stack of interest to all Bluetooth Developer Studio generated Services.
 *
 * @param[in]   p_ble_evt  Event received from the BLE stack.
 */
void bluetooth_on_ble_evt(ble_evt_t * p_ble_evt)
{ 
    ble_quickdraw_on_ble_evt(&m_quickdraw, p_ble_evt); 
}
